package Node;

use strict;
use warnings;
use Data::Dumper;

our %EXPORT_TAGS = ( 'all' => [ qw(

) ] );

our @EXPORT_OK = ( @{ $EXPORT_TAGS{'all'} }  );

our @EXPORT = qw(
);

$Node::i = 0;

sub new
# {{{
{
      my $type = shift;

      $Node::i++;
      my $self = {"name" => $Node::i};

      bless($self, $type);
      return($self);
}
# }}}

sub set_caption
# {{{
{
      my $self = shift;

      $self->{caption} = shift;
}
# }}}

sub set_type
# {{{
{
      my $self = shift;

      $self->{type} = shift;
}
# }}}

sub set_position
# {{{
{
      my $self = shift;

      $self->{position} = shift;
}
# }}}


sub get_last
# {{{
{
      my $self = shift;

      return $self;
}
# }}}

sub get_first
# {{{
{
      my $self = shift;

      return $self;
}
# }}}

sub output
# {{{
{
      my $self = shift;

      my $name = "";

      if (defined($self->{name})) {
            $name = "($self->{name})";
      }

      my $position = '';
      if (defined($self->{position})) {
            $position = ",$self->{position}";
      }
      my $text = qq{\\node [$self->{type}$position] $name {$self->{caption}};};

      return \$text;
}
# }}}
return 1;
